// apachego -- a launcher for apache
//
// Copyright (C) 2007
// Wolfgang Formann
//
// this file is part of the programm patchvista.  This program is
// free software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your
// option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef AgWindow_h
#define AgWindow_h

#include <Qt/qdialog.h>
#include <Qt/qprocess.h>

class QCloseEvent;
class QCheckBox;
class QStackedLayout;
class QLabel;
class QTimer;
class QPushButton;

class AgWindow : public QDialog
{
	Q_OBJECT

private:
    AgWindow();

public:
    ~AgWindow();
	static AgWindow* getInstance();

private:
    enum InstallationStatus {
        eMISS_FILES,
        eMISS_TEMP,
        eMISS_ACCESS,
        eMISS_ALLOKAY
    };
    InstallationStatus checkInstallation();
    QWidget* subPage1();
    QString getTempDir();
	void cleanUp(QString const &dir, bool remove);
    QWidget *page1();
    QWidget *page2();
    QWidget *page3();
    enum StartErrors {
        eSTART_GetPWD,
        eSTART_EnvTemp,
        eSTART_EmptyPhpIni,
        eSTART_MissPhpIni,
        eSTART_Apache,
        eKILL_Apache,
        eDIED_Apache,
        eSTART_FireFox
    };
    void showError(StartErrors error);

private slots:
	void doCancel();
	void doAbout();
	void doStart();
    void enableExit();
    void ffFinished(int exitCode, QProcess::ExitStatus exitStatus);
    void apacheFinished(int exitCode, QProcess::ExitStatus exitStatus);

public slots:

protected:
	void closeEvent(QCloseEvent *event);

private:
	static AgWindow* instance;
    QStackedLayout *_layers;
//    QCheckBox *_usePortableFirefox;
    QTimer *_timer;
    QLabel *_page2Header;
    QPushButton *_cancel3;
    QString _tmpDir;
    QProcess *_apache;
    bool _apacheStarted;
    QProcess *_browser;
    QPushButton *_start;
};
#endif
